#include "./setAsTree.h"

using namespace std;

setAsTree::setAsTree(int v)
{
	ltree = NULL;
	rtree = NULL;
	val = v;
}

setAsTree::setAsTree(const setAsTree& set)
{
	copy(set);
}

setAsTree::~setAsTree()
{
	destroy();
}

setAsTree& setAsTree::operator=(const setAsTree& set)
{
	copy(set);
	return *this;
}

void setAsTree::insert(int v)
{
	if(v > val)
	{
		if(rtree)
			rtree->insert(v);
		else
			rtree = new setAsTree(v);
	}
	else if(v < val)
	{
		if(ltree)
			ltree->insert(v);
		else
			ltree = new setAsTree(v);	
	}
	
}

setAsTree* setAsTree::remove(int v)
{
	return this;
}

int setAsTree::min() const
{
	if(ltree)
		return ltree->max();
	else
		return val;
}

int setAsTree::max() const
{
	if(rtree)
		return rtree->max();
	else
		return val;
}

bool setAsTree::contains(int v) const
{
	if(val == val)
		return true;
	else if(v > val && rtree)
		return rtree->contains(v);
	else if(v < val && ltree)
		return ltree->contains(v);
	else
		return false;
}

void setAsTree::copy(const setAsTree& set)
{
	if(this == &set)
		return;
	
	destroy();
	
	if(set.ltree)
		ltree = new setAsTree(*set.ltree);
	else
		ltree = NULL;
	
	if(set.rtree)
		rtree = new setAsTree(*set.rtree);
	else
		rtree = NULL;
	
	val = set.val;
}

void setAsTree::destroy()
{
	if(rtree)
	{
		delete rtree;
		rtree = NULL;
	}
	
	if(ltree)
	{
		delete ltree;
		ltree = NULL;
	}
}

std::ostream& operator<<(std::ostream& stream,const setAsTree& set)
{
	if(set.ltree)
		stream << *set.ltree;
	
	stream << set.val << " ";
	
	if(set.rtree)
		stream << *set.rtree;
	
	return stream;
}

